//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Client.ObservablePropertyTest.ObservablePropertyTest
{
    
    
    /// <summary>
    /// Class that implements the IObservablePropertyTest interface through SiLA2
    /// </summary>
    public partial class ObservablePropertyTestClient : IObservablePropertyTest, System.ComponentModel.INotifyPropertyChanged, System.IDisposable
    {
        
        private long _fixedValue;
        
        private System.Threading.Tasks.Task _fixedValueUpdateTask;
        
        private bool _alternating;
        
        private System.Threading.Tasks.Task _alternatingUpdateTask;
        
        private long _editable;
        
        private System.Threading.Tasks.Task _editableUpdateTask;
        
        private System.Threading.CancellationTokenSource _cancellationTokenSource = new System.Threading.CancellationTokenSource();
        
        private IClientExecutionManager _executionManager;
        
        private IClientChannel _channel;
        
        private const string _serviceName = "sila2.org.silastandard.test.observablepropertytest.v1.ObservablePropertyTest";
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="channel">The channel through which calls should be executed</param>
        /// <param name="executionManager">A component to determine metadata to attach to any requests</param>
        public ObservablePropertyTestClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            _executionManager = executionManager;
            _channel = channel;
        }
        
        /// <summary>
        /// Always returns 42 and never changes.
        /// </summary>
        public virtual long FixedValue
        {
            get
            {
                if ((_fixedValueUpdateTask == null))
                {
                    try
                    {
                        System.Threading.Monitor.Enter(_cancellationTokenSource);
                        if ((_fixedValueUpdateTask == null))
                        {
                            _fixedValueUpdateTask = _channel.SubscribeProperty<PropertyResponse<Tecan.Sila2.IntegerDto>>(_serviceName, "FixedValue", "org.silastandard/test/ObservablePropertyTest/v1/Property/FixedValue", ReceiveNewFixedValue, _executionManager.CreateCallOptions("org.silastandard/test/ObservablePropertyTest/v1/Property/FixedValue"), _cancellationTokenSource.Token);
                        }
                    } finally
                    {
                        System.Threading.Monitor.Exit(_cancellationTokenSource);
                    }
                }
                return _fixedValue;
            }
        }
        
        /// <summary>
        /// Switches every second between true and false
        /// </summary>
        public virtual bool Alternating
        {
            get
            {
                if ((_alternatingUpdateTask == null))
                {
                    try
                    {
                        System.Threading.Monitor.Enter(_cancellationTokenSource);
                        if ((_alternatingUpdateTask == null))
                        {
                            _alternatingUpdateTask = _channel.SubscribeProperty<PropertyResponse<Tecan.Sila2.BooleanDto>>(_serviceName, "Alternating", "org.silastandard/test/ObservablePropertyTest/v1/Property/Alternating", ReceiveNewAlternating, _executionManager.CreateCallOptions("org.silastandard/test/ObservablePropertyTest/v1/Property/Alternating"), _cancellationTokenSource.Token);
                        }
                    } finally
                    {
                        System.Threading.Monitor.Exit(_cancellationTokenSource);
                    }
                }
                return _alternating;
            }
        }
        
        /// <summary>
        /// Can be set through SetValue command
        /// </summary>
        public virtual long Editable
        {
            get
            {
                if ((_editableUpdateTask == null))
                {
                    try
                    {
                        System.Threading.Monitor.Enter(_cancellationTokenSource);
                        if ((_editableUpdateTask == null))
                        {
                            _editableUpdateTask = _channel.SubscribeProperty<PropertyResponse<Tecan.Sila2.IntegerDto>>(_serviceName, "Editable", "org.silastandard/test/ObservablePropertyTest/v1/Property/Editable", ReceiveNewEditable, _executionManager.CreateCallOptions("org.silastandard/test/ObservablePropertyTest/v1/Property/Editable"), _cancellationTokenSource.Token);
                        }
                    } finally
                    {
                        System.Threading.Monitor.Exit(_cancellationTokenSource);
                    }
                }
                return _editable;
            }
        }
        
        public event System.ComponentModel.PropertyChangedEventHandler PropertyChanged;
        
        private void ReceiveNewFixedValue(PropertyResponse<Tecan.Sila2.IntegerDto> fixedValue)
        {
            long inner = fixedValue.Value.Extract(_executionManager.DownloadBinaryStore);
            if ((_fixedValue != inner))
            {
                _fixedValue = inner;
                System.ComponentModel.PropertyChangedEventHandler handler = PropertyChanged;
                if ((handler != null))
                {
                    handler.Invoke(this, new System.ComponentModel.PropertyChangedEventArgs("FixedValue"));
                }
            }
        }
        
        private void ReceiveNewAlternating(PropertyResponse<Tecan.Sila2.BooleanDto> alternating)
        {
            bool inner = alternating.Value.Extract(_executionManager.DownloadBinaryStore);
            if ((_alternating != inner))
            {
                _alternating = inner;
                System.ComponentModel.PropertyChangedEventHandler handler = PropertyChanged;
                if ((handler != null))
                {
                    handler.Invoke(this, new System.ComponentModel.PropertyChangedEventArgs("Alternating"));
                }
            }
        }
        
        private void ReceiveNewEditable(PropertyResponse<Tecan.Sila2.IntegerDto> editable)
        {
            long inner = editable.Value.Extract(_executionManager.DownloadBinaryStore);
            if ((_editable != inner))
            {
                _editable = inner;
                System.ComponentModel.PropertyChangedEventHandler handler = PropertyChanged;
                if ((handler != null))
                {
                    handler.Invoke(this, new System.ComponentModel.PropertyChangedEventArgs("Editable"));
                }
            }
        }
        
        /// <summary>
        /// Disposes the current client and cancels all subscriptions
        /// </summary>
        public void Dispose()
        {
            _cancellationTokenSource.Cancel();
            _cancellationTokenSource.Dispose();
        }
        
        /// <summary>
        /// Changes the value of Editable
        /// </summary>
        /// <param name="value">The new value</param>
        public virtual void SetValue(long value)
        {
            SetValueRequestDto request = new SetValueRequestDto(value, null);
            request.Validate();
            Tecan.Sila2.Client.IClientCallInfo callInfo = _executionManager.CreateCallOptions("org.silastandard/test/ObservablePropertyTest/v1/Command/SetValue");
            try
            {
                _channel.ExecuteUnobservableCommand<SetValueRequestDto>(_serviceName, "SetValue", request, callInfo);
                callInfo.FinishSuccessful();
                return;
            } catch (System.Exception ex)
            {
                System.Exception exception = _channel.ConvertException(ex);
                callInfo.FinishWithErrors(exception);
                throw exception;
            }
        }
        
        private T Extract<T>(Tecan.Sila2.ISilaTransferObject<T> dto)
        
        {
            return dto.Extract(_executionManager.DownloadBinaryStore);
        }
    }
    
    /// <summary>
    /// Factory to instantiate clients for the Observable Property Test.
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IClientFactory))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class ObservablePropertyTestClientFactory : IClientFactory
    {
        
        /// <summary>
        /// Gets the fully-qualified identifier of the feature for which clients can be generated
        /// </summary>
        public string FeatureIdentifier
        {
            get
            {
                return "org.silastandard/test/ObservablePropertyTest/v1";
            }
        }
        
        /// <summary>
        /// Gets the interface type for which clients can be generated
        /// </summary>
        public System.Type InterfaceType
        {
            get
            {
                return typeof(IObservablePropertyTest);
            }
        }
        
        /// <summary>
        /// Creates a strongly typed client for the given execution channel and execution manager
        /// </summary>
        /// <param name="channel">The channel that should be used for communication with the server</param>
        /// <param name="executionManager">The execution manager to manage metadata</param>
        /// <returns>A strongly typed client. This object will be an instance of the InterfaceType property</returns>
        public object CreateClient(IClientChannel channel, IClientExecutionManager executionManager)
        {
            return new ObservablePropertyTestClient(channel, executionManager);
        }
    }
}

